# coding: utf-8
'''
Created on 14.05.2015

@author: v.popov
'''

from java.util import ArrayList
import json

from common.sysfunctions import tableCursorImport
from ru.curs.celesta.showcase.utils import XMLJSONConverter


try:
    from ru.curs.showcase.core.jython import JythonDTO
    from ru.curs.showcase.core.jython import JythonDownloadResult
    from ru.curs.showcase.core.selector import ResultSelectorData
    from ru.beta2.extra.gwt.ui.selector.api import DataRecord
except:
    from ru.curs.celesta.showcase import JythonDTO


def procListAndCount(context, main=None, add=None, filterinfo=None, session=None, params=None, curValue=None, startsWith=None, firstRecord=None, recordCount=None):

    data = procList(context, main, add, filterinfo, session, params, curValue, startsWith, firstRecord, recordCount)
    count = procCount(context, main, add, filterinfo, session, params, curValue, startsWith)
    return ResultSelectorData(data.getDataRecordList(), count.getCount())

def procCount(context, main, add, filterinfo, session, params, curValue, startsWith):

    param = json.loads(XMLJSONConverter.xmlToJson(params))['schema']['filter']['param']['value_type']
    cur = tableCursorImport(param['grain'], param['table'])(context)
    count = cur.count()

    return ResultSelectorData(None, count)

def procList(context, main, add, filterinfo, session, params, curValue, startsWith, firstRecord, recordCount):

    param = json.loads(XMLJSONConverter.xmlToJson(params))['schema']['filter']['param']['value_type']
    cur = tableCursorImport(param['grain'], param['table'])(context)
    cur.setFilter(param['name_field'], "@%s'%s'%%" % ('%' * (not startsWith), curValue))
    cur.limit(firstRecord, recordCount)
    cur.orderBy(param['name_field'])
    recordList = ArrayList()
    for row in cur.iterate():
        rec = DataRecord()
        rec.id = str(getattr(row, param['id_field']))
        rec.name = unicode(getattr(row, param['name_field']))
        # дополнительные поля
        if 'name_add_fields' in param:
            if isinstance(param['name_add_fields'], list):
                for x in param['name_add_fields']:
                    if hasattr(row, x):
                        rec.name = u'%s - %s' % (rec.name, unicode(getattr(row, x)))
            elif isinstance(param['name_add_fields'], unicode):
                if hasattr(row, param['name_add_fields']):
                    rec.name = u'%s - %s' % (rec.name, unicode(getattr(row, param['name_add_fields'])))
        recordList.add(rec)

    return ResultSelectorData(recordList, 0)
