# coding: utf-8

from java.util import ArrayList
import json

from ru.curs.celesta.showcase.utils import XMLJSONConverter
from umk._umk_orm import umk_versionCursor


try:
    from ru.curs.showcase.core.jython import JythonDTO
    from ru.curs.showcase.core.jython import JythonDownloadResult
    from ru.curs.showcase.core.selector import ResultSelectorData
    from ru.beta2.extra.gwt.ui.selector.api import DataRecord
except:
    from ru.curs.celesta.showcase import JythonDTO


def procListAndCount(context, main=None, add=None, filterinfo=None, session=None, params=None, curValue=None, startsWith=None, firstRecord=None, recordCount=None):

    data = procList(context, main, add, filterinfo, session, params, curValue, startsWith, firstRecord, recordCount)
    count = procCount(context, main, add, filterinfo, session, params, curValue, startsWith)
    return ResultSelectorData(data.getDataRecordList(), count.getCount())

def procCount(context, main, add, filterinfo, session, params, curValue, startsWith):

    umk_version = umk_versionCursor(context)

    params = json.loads(XMLJSONConverter.xmlToJson(params))
    complex_program_id = params['schema']['filter']['complex_program_id']

    umk_version.setRange('complex_program_id', complex_program_id)
    umk_version.setFilter('status_id', "3|4")
    umk_version.orderBy('number')

#    raise Exception(startsWith, curValue)
#    if curValue <> "":
#        umk_version.setFilter('number', "@%s'%s'%%" % ("%" * (not startsWith), curValue))
    count = umk_version.count()

    return ResultSelectorData(None, count)

def procList(context, main, add, filterinfo, session, params, curValue, startsWith, firstRecord, recordCount):

    umk_version = umk_versionCursor(context)

    params = json.loads(XMLJSONConverter.xmlToJson(params))
    complex_program_id = params['schema']['filter']['complex_program_id']

    umk_version.setRange('complex_program_id', complex_program_id)
    umk_version.setFilter('status_id', "3|4")
    umk_version.orderBy('number')

#    if curValue <> "":
#        umk_version.setFilter('number', "@%s'%s'%%" % ("%" * (not startsWith), curValue))

    umk_version.limit(firstRecord, recordCount)
    recordList = ArrayList()

    for umk_version in umk_version.iterate():
        rec = DataRecord()
        rec.id = umk_version.uid
        rec.name = unicode(umk_version.number)
        recordList.add(rec)

    return ResultSelectorData(recordList, 0)
